/* vsiptest_cstorage.c.c Version 0.000 March 29, 1999
//
// This file contains the vsiptest_blockrebind_f functionality.
//
// Functional Description:
//
// Copyright March 1999, Georgia Institute of Technology.
// This is an unpublished work. All rights reserved.
//
// Author: Dan Campbell 
//         dan.campbell@gtri.gatech.edu
//
// Test description:
//   Verify that cstorage returns the same as macro VSIP_CMPLX_MEM
//   Verify that cstorage returns a valid value
// 
//      
// Revision History:
// March 29, 1999  Created 
*/


#include <stdio.h>
#include <stdlib.h>
#include "vsiptest_block.h"

int main()
{
  int ret = 0;
  vsip_cmplx_mem complex;

  vsip_init ((void *)0);

  complex = vsip_cstorage();
  
  if (complex != VSIP_CMPLX_MEM)
  {
    vtprintf ("Error in vsip_cstorage(); (1)\n"
              "value returned did not match macro VSIP_CMPLX_MEM\n");
    ret |= 1<<1;
  }

  if (complex != VSIP_CMPLX_NONE &&
      complex != VSIP_CMPLX_INTERLEAVED &&
      complex != VSIP_CMPLX_NONE)
  {
    vtprintf ("Error in vsip_cstorage(); (2)\n"
              "value returned not valid\n");
    ret |= 1<<2;
  }

  report (0);
  vsip_finalize ((void *)0);
  return (0);
}
