#ifndef _ELWISE_H_
#define _ELWISE_H_

/* vsiptest_elwise.h Version 0.001 1 September 1999
//
// This file contains the vsiptest_elwise.h header information
// for all element wise related functions.
//
// Copyright May 1999, Georgia Institute of Technology.
// This is an unpublished work. All rights reserved.
//
// Author: Dan Campbell
//         dan.campbell@gtri.gatech.edu
//
// Revision History:
// Sep  1, 1999 - Creted
*/

/* Include files for testing the elwise functions */

#include"vsip.h"
#include"vsiptest_util.h"
#include"vsiptest_error.h"

#define elements(x) sizeof(x)/sizeof(x[0])

const int VSIPTEST_ELWISE_LEFT_STRIDES[] = {2, 3, 4};
const int VSIPTEST_ELWISE_RIGHT_STRIDES[] = {1, -1, 1};

const int VSIPTEST_VFILL_F_VALUES[] = {-1, 0, 1, 2};
const int VSIPTEST_VFILL_F_LENGTH = 50;

const int VSIPTEST_VRAMP_F_MINVALUES[] = {-1, 0, 1};
const int VSIPTEST_VRAMP_F_STEPS[] = {1, 3, .5};

#define VT_EM .005

#endif
