/* vsiptest_block.h Version 0.001 18 March 1999
//
// This file contains the vsiptest_block.h header information
// for all block related functions.
//
// Copyright May 1997, Georgia Institute of Technology.
// This is an unpublished work. All rights reserved.
//
// Author: Thomas Egolf
//         egolf@ece.gatech.edu
// Adapted by: Randall Janka
//             randall.janka@gtri.gatech.edu
//
// Revision History:
// May 6, 1997	Added copyright notice.
// 18 March 1999  Adapted for TSL.     */

/* Include files for testing the block functions */

#include"vsip.h"
#include"vsiptest_util.h"
#include "vsiptest_error.h"

#define elements(x) sizeof(x)/sizeof(x[0])

const int VSIPTEST_CCFFTOP_F_NUMFILES             = 8;
#define   VSIPTEST_CCFFTOP_F_BASENAME              "ccfftop_f"
const float VSIPTEST_CCFFTOP_F_MAX_EPSILON          = .001;

const int VSIPTEST_RCFFTOP_F_NUMFILES             = 4;
#define   VSIPTEST_RCFFTOP_F_BASENAME              "rcfftop_f"
const float VSIPTEST_RCFFTOP_F_MAX_EPSILON          = .001;

const int VSIPTEST_CRFFTOP_F_NUMFILES             = 4;
#define   VSIPTEST_CRFFTOP_F_BASENAME              "crfftop_f"
const float VSIPTEST_CRFFTOP_F_MAX_EPSILON          = .001;

const int VSIPTEST_FIRFLT_F_NUMFILES             = 9;
#define   VSIPTEST_FIRFLT_F_BASENAME               "firflt_f"
const float VSIPTEST_FIRFLT_F_MAX_EPSILON          = .001;

const int VSIPTEST_CFIRFLT_F_NUMFILES             = 4;
#define   VSIPTEST_CFIRFLT_F_BASENAME              "cfirflt_f"
const float VSIPTEST_CFIRFLT_F_MAX_EPSILON          = .001;

const int VSIPTEST_VHISTO_F_NUMFILES             = 3;
#define   VSIPTEST_VHISTO_F_BASENAME              "vhisto_f"
const float VSIPTEST_VHISTO_F_MAX_EPSILON          = .001;

const int VSIPTEST_VRANDU_F_NUMFILES             = 12;
#define   VSIPTEST_VRANDU_F_BASENAME              "vrandu_f"
const float VSIPTEST_VRANDU_F_MAX_EPSILON          = .001;
const int VSIPTEST_RANDCREATE_NPSEED             = 10234;
const int VSIPTEST_RANDCREATE_NPPROCS            = 3;
const int VSIPTEST_RANDCREATE_NPID               = 1;
const int VSIPTEST_VRANDU_F_NPSIZE               = 5000;


