/* vsiptest_block.h Version 0.001 18 March 1999
//
// This file contains the vsiptest_block.h header information
// for all block related functions.
//
// Copyright May 1997, Georgia Institute of Technology.
// This is an unpublished work. All rights reserved.
//
// Author: Thomas Egolf
//         egolf@ece.gatech.edu
// Adapted by: Randall Janka
//             randall.janka@gtri.gatech.edu
//
// Revision History:
// May 6, 1997	Added copyright notice.
// 18 March 1999  Adapted for TSL.     */

/* Include files for testing the block functions */

#include"vsip.h"
#include"vsiptest_util.h"

#define elements(x) sizeof(x)/sizeof(x[0])

/* viewutil functions */

void vput_i (vsip_vview_i *view, int pos, vsip_scalar_i val);
vsip_scalar_i vget_i (vsip_vview_i *view, int pos);

/* vdestroy_i */
const int VSIPTEST_VDESTROY_I_SIZE_ARRAY[] = {2, 100, 500, 5000};

/* vdestroy_f */
const int VSIPTEST_VDESTROY_F_SIZE_ARRAY[] = {2, 100, 500, 5000};

/* cvdestroy_f */
const int VSIPTEST_CVDESTROY_F_SIZE_ARRAY[] = {2, 100, 500, 5000};

/* vbind_f */
const int VSIPTEST_VBIND_F_BLOCK_SIZE = 5000;
const int VSIPTEST_VBIND_F_OFFSET[] = {4999, 0, 0,    0,    0,    0,    0};
const int VSIPTEST_VBIND_F_STRIDE[] = {-1  , 0, 1,    2,    3,    1,    1};
const int VSIPTEST_VBIND_F_LENGTH[] = {5000, 1, 5000, 2500, 1666, 2500, 5000};

/* vbind_i */
const int VSIPTEST_VBIND_I_BLOCK_SIZE = 500;
const int VSIPTEST_VBIND_I_OFFSET[] = {499, 0, 0,    0,    0,    0,    0};
const int VSIPTEST_VBIND_I_STRIDE[] = {-1  , 0, 1,    2,    3,    1,    1};
const int VSIPTEST_VBIND_I_LENGTH[] = {500, 1, 500, 250, 166, 250, 500};

/* cvbind_f */
const int VSIPTEST_CVBIND_F_BLOCK_SIZE = 5000;
const int VSIPTEST_CVBIND_F_OFFSET[] = {4999, 0, 0,    0,    0,    0,    0};
const int VSIPTEST_CVBIND_F_STRIDE[] = {-1  , 0, 1,    2,    3,    1,    1};
const int VSIPTEST_CVBIND_F_LENGTH[] = {5000, 1, 5000, 2500, 1666, 2500, 5000};

/* cvcreate_f */
const int VSIPTEST_CVCREATE_F_BLOCK_SIZE[] = {1, 10, 500, 5000};

/* vcreate_f */
const int VSIPTEST_VCREATE_F_BLOCK_SIZE[] = {1, 10, 500, 5000};

/* vcloneview_f */
const int VSIPTEST_VCLONEVIEW_F_BLOCK_SIZE = 5000;
const int VSIPTEST_VCLONEVIEW_F_OFFSET[] = {0,    3};
const int VSIPTEST_VCLONEVIEW_F_STRIDE[] = {1,    2};
const int VSIPTEST_VCLONEVIEW_F_LENGTH[] = {5000, 2497};

/* cvcloneview_f */
const int VSIPTEST_CVCLONEVIEW_F_BLOCK_SIZE = 5000;
const int VSIPTEST_CVCLONEVIEW_F_OFFSET[] = {0,    3};
const int VSIPTEST_CVCLONEVIEW_F_STRIDE[] = {1,    2};
const int VSIPTEST_CVCLONEVIEW_F_LENGTH[] = {5000, 2497};

/* vrealview_f (and vimagview_f) */
const int VSIPTEST_VREALVIEW_F_BLOCK_SIZE = 5000;
const int VSIPTEST_VREALVIEW_F_OFFSET[] = {0,    2500, 500};
const int VSIPTEST_VREALVIEW_F_STRIDE[] = {1,    2,    -1};
const int VSIPTEST_VREALVIEW_F_LENGTH[] = {5000, 1000, 500};

/* cvsubview_f */
const int VSIPTEST_CVSUBVIEW_F_BLOCK_SIZE = 5000;
const int VSIPTEST_CVSUBVIEW_F_INDEX[] =  {0,    2500, 4999};
const int VSIPTEST_CVSUBVIEW_F_LENGTH[] = {2000, 2000, 1};
const int VSIPTEST_CVSUBVIEW_F_SUBINDEX = 2000;

/* vsubview_f */
const int VSIPTEST_VSUBVIEW_F_BLOCK_SIZE = 5000;
const int VSIPTEST_VSUBVIEW_F_INDEX[] =  {0,    2500, 4999};
const int VSIPTEST_VSUBVIEW_F_LENGTH[] = {2000, 2000, 1};
const int VSIPTEST_VSUBVIEW_F_SUBINDEX = 2000;

/* cvput_f */
const int VSIPTEST_CVPUT_F_BLOCK_SIZE = 5000;
const int VSIPTEST_CVPUT_F_OFFSET[] = {3,    101,  504, 1,    0};
const int VSIPTEST_CVPUT_F_STRIDE[] = {1,    2,    -1,  2,    3};
const int VSIPTEST_CVPUT_F_LENGTH[] = {4997, 1000, 505, 2499, 1666};

/* vput_f */
const int VSIPTEST_VPUT_F_BLOCK_SIZE = 5000;
const int VSIPTEST_VPUT_F_OFFSET[] = {3,    101,  504, 1,    0};
const int VSIPTEST_VPUT_F_STRIDE[] = {1,    2,    -1,  2,    3};
const int VSIPTEST_VPUT_F_LENGTH[] = {4997, 1000, 505, 2499, 1666};

/* vget_f */
const int VSIPTEST_VGET_F_BLOCK_SIZE = 5000;
const int VSIPTEST_VGET_F_OFFSET[] = {3,    101,  504, 1,    0};
const int VSIPTEST_VGET_F_STRIDE[] = {1,    2,    -1,  2,    3};
const int VSIPTEST_VGET_F_LENGTH[] = {4997, 1000, 505, 2499, 1666};

/* cvget_f */
const int VSIPTEST_CVGET_F_BLOCK_SIZE = 5000;
const int VSIPTEST_CVGET_F_OFFSET[] = {3,    101,  504, 1,    0};
const int VSIPTEST_CVGET_F_STRIDE[] = {1,    2,    -1,  2,    3};
const int VSIPTEST_CVGET_F_LENGTH[] = {4997, 1000, 505, 2499, 1666};

/* imag_f */
const int VSIPTEST_IMAG_F_BLOCK_SIZE = 5000;

/* real_f */
const int VSIPTEST_REAL_F_BLOCK_SIZE = 5000;

/* cmplx_f */
const int VSIPTEST_CMPLX_F_REAL_MIN = -5;
const int VSIPTEST_CMPLX_F_REAL_MAX = 5;
const int VSIPTEST_CMPLX_F_IMAG_MIN = -5;
const int VSIPTEST_CMPLX_F_IMAG_MAX = 5;

/* vcopy_p */
const int VSIPTEST_VCOPY_F_F_BLOCK_SIZE_BASE[] = {3, 7, 13, 23};
const int VSIPTEST_VCOPY_I_F_BLOCK_SIZE_BASE[] = {3, 7, 13, 23};
const int VSIPTEST_VCOPY_F_I_BLOCK_SIZE_BASE[] = {3, 7, 13, 23};
const int VSIPTEST_CVCOPY_F_F_BLOCK_SIZE_BASE[] = {3, 7, 13, 23};

/* valldestroy_f */
const int VSIPTEST_VALLDESTROY_F_ITERATIONS = 500;
const int VSIPTEST_VALLDESTROY_F_BLOCK_SIZE = 500;

/* cvalldestroy_f */
const int VSIPTEST_CVALLDESTROY_F_ITERATIONS = 500;
const int VSIPTEST_CVALLDESTROY_F_BLOCK_SIZE = 500;

/* vgetattrib_f */
const int VSIPTEST_VGETATTRIB_F_BLOCK_LENGTH = 500;
const int VSIPTEST_VGETATTRIB_F_OFFSET[] = {499,   0, 100, 0  };
const int VSIPTEST_VGETATTRIB_F_STRIDE[] = { -1,   2,   1, 3  };
const int VSIPTEST_VGETATTRIB_F_LENGTH[] = {500, 250, 400, 150};

/* vgetattrib_i */
const int VSIPTEST_VGETATTRIB_I_BLOCK_LENGTH = 500;
const int VSIPTEST_VGETATTRIB_I_OFFSET[] = {499,   0, 100, 0  };
const int VSIPTEST_VGETATTRIB_I_STRIDE[] = { -1,   2,   1, 3  };
const int VSIPTEST_VGETATTRIB_I_LENGTH[] = {500, 250, 400, 150};

/* vgetattrib_f */
const int VSIPTEST_CVGETATTRIB_F_BLOCK_LENGTH = 500;
const int VSIPTEST_CVGETATTRIB_F_OFFSET[] = {499,   0, 100, 0  };
const int VSIPTEST_CVGETATTRIB_F_STRIDE[] = { -1,   2,   1, 3  };
const int VSIPTEST_CVGETATTRIB_F_LENGTH[] = {500, 250, 400, 150};

/* cvgetblock_f */
const int VSIPTEST_CVGETBLOCK_F_BLOCK_LENGTH = 500;

/* vgetblock_f */
const int VSIPTEST_VGETBLOCK_F_BLOCK_LENGTH = 500;

/* vputattrib_f */
const int VSIPTEST_VPUTATTRIB_F_BLOCK_LENGTH = 500;
const int VSIPTEST_VPUTATTRIB_F_OFFSET[] = {499,   0, 100, 0  };
const int VSIPTEST_VPUTATTRIB_F_STRIDE[] = { -1,   2,   1, 3  };
const int VSIPTEST_VPUTATTRIB_F_LENGTH[] = {500, 250, 400, 150};

/* cvputattrib_f */
const int VSIPTEST_CVPUTATTRIB_F_BLOCK_LENGTH = 500;
const int VSIPTEST_CVPUTATTRIB_F_OFFSET[] = {499,   0, 100, 0  };
const int VSIPTEST_CVPUTATTRIB_F_STRIDE[] = { -1,   2,   1, 3  };
const int VSIPTEST_CVPUTATTRIB_F_LENGTH[] = {500, 250, 400, 150};

/* vputattrib_i */
const int VSIPTEST_VPUTATTRIB_I_BLOCK_LENGTH = 500;
const int VSIPTEST_VPUTATTRIB_I_OFFSET[] = {499,   0, 100, 0  };
const int VSIPTEST_VPUTATTRIB_I_STRIDE[] = { -1,   2,   1, 3  };
const int VSIPTEST_VPUTATTRIB_I_LENGTH[] = {500, 250, 400, 150};

/* vputoffset_f */
const int VSIPTEST_VPUTOFFSET_F_BLOCK_LENGTH = 500;
const int VSIPTEST_VPUTOFFSET_F_OFFSET[] = {499, 250,   1,   0};
const int VSIPTEST_VPUTOFFSET_F_STRIDE[] = {  1,   1,   1,   1};
const int VSIPTEST_VPUTOFFSET_F_LENGTH[] = {  1, 250, 499, 150};

/* cvputoffset_f */
const int VSIPTEST_CVPUTOFFSET_F_BLOCK_LENGTH = 500;
const int VSIPTEST_CVPUTOFFSET_F_OFFSET[] = {499, 250,   1,   0};
const int VSIPTEST_CVPUTOFFSET_F_STRIDE[] = {  1,   1,   1,   1};
const int VSIPTEST_CVPUTOFFSET_F_LENGTH[] = {  1, 250, 499, 150};

/* vputstride_f */
const int VSIPTEST_VPUTSTRIDE_F_BLOCK_LENGTH = 500;
const int VSIPTEST_VPUTSTRIDE_F_OFFSET[] = {  0,   0,   0, 499};
const int VSIPTEST_VPUTSTRIDE_F_STRIDE[] = {  1,   2, 250,  -1};
const int VSIPTEST_VPUTSTRIDE_F_LENGTH[] = {  1, 250,   2, 500};

/* cvputstride_f */
const int VSIPTEST_CVPUTSTRIDE_F_BLOCK_LENGTH = 500;
const int VSIPTEST_CVPUTSTRIDE_F_OFFSET[] = {  0,   0,   0, 499};
const int VSIPTEST_CVPUTSTRIDE_F_STRIDE[] = {  1,   2, 250,  -1};
const int VSIPTEST_CVPUTSTRIDE_F_LENGTH[] = {  1, 250,   2, 500};

/* vputlength_f */
const int VSIPTEST_VPUTLENGTH_F_BLOCK_LENGTH = 500;
const int VSIPTEST_VPUTLENGTH_F_OFFSET[] = {499, 250,   1,   0};
const int VSIPTEST_VPUTLENGTH_F_STRIDE[] = {  1,   1,   1,   1};
const int VSIPTEST_VPUTLENGTH_F_LENGTH[] = {  1, 250, 499, 150};

/* cvputlength_f */
const int VSIPTEST_CVPUTLENGTH_F_BLOCK_LENGTH = 500;
const int VSIPTEST_CVPUTLENGTH_F_OFFSET[] = {499, 250,   1,   0};
const int VSIPTEST_CVPUTLENGTH_F_STRIDE[] = {  1,   1,   1,   1};
const int VSIPTEST_CVPUTLENGTH_F_LENGTH[] = {  1, 250, 499, 150};

