% Filter Generation for vsip_firflt_gen.m
%
%   M = Filter order
% M+1 = Number of filter coefficients
%

%Type I filter coefficient generation
%Even coefficient symmetry
%M is odd; M+1 coefficients (even # coeffs)
%VSIPL_SYM_EVEN_LEN_EVEN
bI=fir1(M_odd,0.4);
%Type II filter coefficient generation
%Even coefficient symmetry
%M is even; M+1 coefficients (odd # coeffs)
%VSIPL_SYM_EVEN_LEN_ODD
bII=fir1(M_even,0.4);

% From firls man-pages in The MathWorks'
%   "Signal Processing Toolbox" user's guide,
%   p. 6-142 -- 6-146
f=[0 .3 .4 .6 .7 .9];
a=[0  1  0  0 .5 .5];
%Type III filter coefficient generation
%Odd coefficient symmetry
bIII=firls(M_odd,f,a,'hilbert');
%Type IV filter coefficient generation
%Odd coefficient symmetry
bIV=firls(M_even,f,a,'hilbert');
