%File:							vsip_cvdot_gen.m
%	
%Author:							Randy Janka
%Date:							11/26/99
%Reference:			
%
%Purpose:						Generate test data for vsip_cvdot_f
%									Generate x1=u+jv & x2=r+js
%										and y=x1*x2
%										where x1 & x2 are vectors of length N
%	
%Parameters:					N = Length = length(x) = 1403
%									DATAPATH = dir where data file is to go;
%										set in workspace

%x=0
%
x0=0;

%x>0
%
xpos=10.^[-7:0.02:7];

%x<0
%
xneg=-fliplr(xpos);

%Form x
x=[xneg,x0,xpos];
u=shuffle(x);
v=shuffle(u);
x1_out=u+j*v;
r=shuffle(v);
s=shuffle(r);
x2_out=r+j*s;

%Form y
y_out=x1_out*x2_out.';

%Write data file
N=length(x1_out);
out=[real(x1_out); imag(x1_out); real(x2_out); imag(x2_out)];
fid=fopen([DATAPATH,'\cvdot_f'],'w');
fprintf(fid,'%4d\n',N);
fprintf(fid,'%12.7e\t%12.7e\t%12.7e\t%12.7e\n',out);
fprintf(fid,'%12.7e\n',y_out);
status=fclose(fid);

if ~status
   disp('cvdot_f write successful.')
else
   disp('cvdot_f write NOT successful.')
end
