%File:							vsip_cvjdot_gen.m
%	
%Author:							Randy Janka
%Date:							12/3/99
%Reference:			
%
%Purpose:						Generate test data for vsip_cvjdot_f
%									Generate x1=u+jv & x2=r+js
%										and y=x1*conj(x2)
%										where x1 & x2 are vectors of length N
%	
%Parameters:					N = Length = length(x) = 536
%									DATAPATH = dir where data file is to go;
%										set in workspace

%x=0
%
x0=0;

%x>0
%
xpos=10.^[-2:0.03:2];

%x<0
%
xneg=-(10.^[-2:0.01:2]);

%Form x
x=[xneg,x0,xpos];
N=length(x);
u=shuffle(x);
v=shuffle(u);
x1_out=(u+j*v)/sqrt(N);
%x1_out=(u+j*v);
r=shuffle(v);
s=shuffle(r);
x2_out=(r+j*s)/sqrt(N);
%x2_out=(r+j*s);

%Form y
y_out=x1_out*x2_out';

%Write data file
out=[real(x1_out); imag(x1_out); real(x2_out); imag(x2_out)];
fid=fopen([DATAPATH,'\cvjdot_f'],'w');
fprintf(fid,'%4d\n',N);
fprintf(fid,'%12.7e,%12.7e\n',real(y_out),imag(y_out));
fprintf(fid,'%12.7e,%12.7e\t%12.7e,%12.7e\n',out);
status=fclose(fid);

if ~status
   disp('cvjdot_f write successful.')
else
   disp('cvjdot_f write NOT successful.')
end
