%File:							vsip_rcvmul_gen.m
%	
%Author:							Randy Janka
%Date:							11/27/99
%Reference:			
%
%Purpose:						Generate test data for vsip_rcvmul_f
%									Generate x1=a & x2=c+jd and y=x1.*x2
%										where x1 & x2 are vectors of length N
%	
%Parameters:					N = Length = length(x) = 563
%									DATAPATH = dir where data file is to go;
%										set in workspace

%x=0
%
x0=0;

%x>0
%
xpos=10.^[-7:0.05:7];

%x<0
%
xneg=-fliplr(xpos);

%Form x
x=[xneg,x0,xpos];
u=shuffle(x);
x1_out=u;
r=shuffle(u);
s=shuffle(r);
x2_out=r+j*s;

%Form y
y_out=x1_out.*x2_out;
%Write data file
N=length(y_out);
out=[x1_out; real(x2_out); imag(x2_out); real(y_out); imag(y_out)];
fid=fopen([DATAPATH,'\cvmul_f'],'w');
fprintf(fid,'%4d\n',N);
fprintf(fid,'%12.7e\t%12.7e\t%12.7e\t%12.7e\t%12.7e\n',out);
status=fclose(fid);

if ~status
   disp('rcvmul_f write successful.')
else
   disp('rcvmul_f write NOT successful.')
end
