%File:							vsip_rscvmul_gen.m
%	
%Author:							Randy Janka
%Date:							12/5/99
%Reference:			
%
%Purpose:						Generate test data for vsip_rscvmul_f
%									Generate x1=a+jb & x2=c and y=x2*x1
%										where x1 is a scalar
%										& x2 is a vector of length N
%	
%Parameters:					N = Length = length(x) = 403
%									DATAPATH = dir where data file is to go;
%										set in workspace

%x=0
%
x0=0;

%x>0
%
xpos=10.^[-2:0.02:2];

%x<0
%
xneg=-fliplr(xpos);

%Form x
x=[xneg,x0,xpos];
u=shuffle(x);
v=shuffle(u);
x1_out=u+j*v;
x2_out=12.34;

%Form y
y_out=x2_out*x1_out;
%Write data file
N=length(y_out);
out=[real(x1_out); imag(x1_out); real(y_out); imag(y_out)];
fid=fopen([DATAPATH,'\rscvmul_f'],'w');
fprintf(fid,'%4d\n',N);
fprintf(fid,'%12.7e\n',x2_out);
fprintf(fid,'%12.7e,%12.7e\t%12.7e,%12.7e\n',out);
status=fclose(fid);

if ~status
   disp('rscvmul_f write successful.')
else
   disp('rscvmul_f write NOT successful.')
end
