%File:						vsip_svdiv_gen.m
%
%Author:						Randy Janka
%Date:						12/3/99
%Reference:					
%
%Purpose:					Generate test data for vsip_svdiv_f
%								Generate x & s and y=s/v
%									where x is a vector of length N
%
%Parameters:				N = Length = length(x) = 535
%								DATAPATH = dir where data file is to go;
%									set in workspace

%x>0
%
xpos=10.^[-2:0.03:2];

%x<0
%
xneg=-(10.^[-2:0.01:2]);

%Form x
x=[xneg,xpos];
x_out=shuffle(x);
s=123.456;

%Form y
y_out=s./x_out;

%Write data file
N=length(x_out);
out=[x_out; y_out];
fid=fopen([DATAPATH,'\svdiv_f'],'w');
fprintf(fid,'%4d\n',N);
fprintf(fid,'%12.7e\n',s);
fprintf(fid,'%12.7e\t%12.7e\n',out);
status=fclose(fid);

if ~status
   disp('svdiv_f write successful.')
else
   disp('svdiv_f write NOT successful.')
end
