%File:						vsip_vdiv_gen.m
%
%Author:						Randy Janka
%Date:						12/5/99
%Reference:					
%
%Purpose:					Generate test data for vsip_vdiv_f
%								Generate x1 & x2 and y=x1./x2
%									where x1 & x2 are vectors of length N
%
%Parameters:				N = Length = length(x) = 535
%								DATAPATH = dir where data file is to go;
%									set in workspace

%x>0
%
xpos=10.^[-2:0.03:2];

%x<0
%
xneg=-(10.^[-2:0.01:2]);

%Form x
x=[xneg,xpos];
x1_out=shuffle(x);
x2_out=shuffle(x1_out);

%Form y
y_out=x1_out./x2_out;

%Write data file
N=length(x1_out);
out=[x1_out; x2_out; y_out];
fid=fopen([DATAPATH,'\vdiv_f'],'w');
fprintf(fid,'%4d\n',N);
fprintf(fid,'%12.7e\t%12.7e\t%12.7e\n',out);
status=fclose(fid);

if ~status
   disp('vdiv_f write successful.')
else
   disp('vdiv_f write NOT successful.')
end
