%File:							vsip_vimag_gen.m
%	
%Author:							Randy Janka
%Date:							12/8/99
%Reference:			
%
%Purpose:						Generate test data for vsip_vimag_f
%									Generate x=a+jb and y=imag(x)
%										where x & y are vectors of length N
%	
%Parameters:					N = Length = length(x) = 500
%									DATAPATH = dir where data file is to go;
%										set in workspace

%Form x
%
N=500;
x_re=[-N/2:(N/2)-1];
x_im=fliplr(x_re);
x=x_re+j*x_im;

%Form y
y=imag(x);

%Write data file
out=[x_re; x_im; y];
fid=fopen([DATAPATH,'\vimag_f'],'w');
fprintf(fid,'%4d\n',N);
fprintf(fid,'%12.7e,%12.7e\t%12.7e\n',out);
status=fclose(fid);

if ~status
   disp('vimag_f write successful.')
else
   disp('vimag_f write NOT successful.')
end
