%File:							vsip_vramp_gen.m
%	
%Author:							Randy Janka
%Date:							11/29/99
%Reference:			
%
%Purpose:						Generate test data for vsip_vramp_f
%									Generate y_int & y_rat & ramp_val_*
%										where y_* is a vector of length N
%										and ramp_val_* = 1 & 3.1416
%	
%Parameters:					N = Length = length(x) = 2000
%									DATAPATH = dir where data file is to go;
%										set in workspace

N=2000;

%Form y1
%
ramp_val_int=1;
N_int=N*ramp_val_int;
y_int=[-N_int/2:ramp_val_int:(N_int/2-ramp_val_int)];

%Form y2
ramp_val_rat=3.1416;
N_rat=N*ramp_val_rat;
y_rat=[-N_rat/2:ramp_val_rat:(N_rat/2)-ramp_val_rat];

%Write data file
y_out=[y_int; y_rat];
fid=fopen([DATAPATH,'\vramp_f'],'w');
fprintf(fid,'%4d\t%12.7e\t%4d\n',ramp_val_int,ramp_val_rat,N);
fprintf(fid,'%12.7e\t%12.7e\n',y_out);
status=fclose(fid);

if ~status
   disp('vramp_f write successful.')
else
   disp('vramp_f write NOT successful.')
end
