%File:						vsip_vrecip_gen.m
%
%Author:						Randy Janka
%Date:						11/26/99
%Reference:				
%
%Purpose:					Generate test data for vsip_vrecip_f
%								Generate x and y=1/x; x!==0
%								where x is a vector of length N
%
%Parameters:				N = Length = length(x) = 1022
%								DATAPATH = dir where data file is to go;
%									set in workspace

%Primary range:			|x|<xmax; xmax=5
delta=0.01;
xmin=delta;
xmax=5;
x0pos=[xmin:delta:xmax];
x0neg=-fliplr(x0pos);

%Large values of |x|:	xmax<|x|<10^7 for single precision
xpos=[[6:9],10.^[1:7]];
xneg=-fliplr(xpos);

%Form x
x=[xneg,x0neg,x0pos,xpos];
x_out=shuffle(x);

%Form y
y_out=1./x_out;

%Write data file
N=length(x);
out=[x_out; y_out];
fid=fopen([DATAPATH,'\vrecip_f'],'w');
fprintf(fid,'%4d\n',N);
fprintf(fid,'%12.7e\t%12.7e\n',out);
status=fclose(fid);

if ~status
   disp('vrecip_f write successful.')
else
   disp('vrecip_f write NOT successful.')
end
