%File:						vsip_vsumsqval_gen.m
%
%Author:						Randy Janka
%Date:						12/1/99
%Reference:					
%
%Purpose:					Generate test data for vsip_vsumsqval_f
%								Generate x and y=sum(x.^2)
%									where x is a vector of length N
%
%Parameters:				N = Length = length(x) = 536
%								DATAPATH = dir where data file is to go;
%									set in workspace

%x=0
%
x0=0;

%x>0
%
xpos=10.^[-2:0.03:2];

%x<0
%
xneg=-(10.^[-2:0.01:2]);

%Form x
x=[xneg,x0,xpos];
x_out=shuffle(x);

%Form y
y_out=sum(x_out.^2);

%Write data file
N=length(x_out);
fid=fopen([DATAPATH,'\vsumsqval_f'],'w');
fprintf(fid,'%4d\n',N);
fprintf(fid,'%12.7e\n',y_out);
fprintf(fid,'%12.7e\n',x_out);
status=fclose(fid);

if ~status
   disp('vsumsqval_f write successful.')
else
   disp('vsumsqval_f write NOT successful.')
end
