#include "vsip.h"
#include "vsiptest_elwise.h"
#include "vsiptest_elwise_test_defs.h"

int vtgetlength (FILE *fp)
{
  char buffer[512];
  int val = 0;
  int read = 0;

  while (!val && !feof (fp))
  {
    fscanf (fp, "%s\n", buffer);
    if (buffer[0] == '#')
    {
      continue;
    }
    read = sscanf (buffer, "%i", &val);
    if (!read)
    {
      val = 0;
    }
  }
  return (val); 
}

int vtelwise_get_length (char *filename)
{
  int val;
  FILE *fp = fopen (filename, "r");
  if (!fp)
  {
    return (0); 
  }

  val = vtgetlength (fp);
  fclose (fp);
  return (val); 
}

#ifdef VSIPTEST_RCVMUL_F
  #include "vsiptest_rcvmul_f.c"
#endif

#ifdef VSIPTEST_VDOT_F
  #include "vsiptest_vdot_f.c"
#endif

#ifdef VSIPTEST_VCMPLX_F
  #include "vsiptest_vcmplx_f.c"
#endif

#ifdef VSIPTEST_VFILL_F
  #include "vsiptest_vfill_f.c"
#endif

#ifdef VSIPTEST_VRAMP_F
  #include "vsiptest_vramp_f.c"
#endif

#ifdef VSIPTEST_ELWISE_RSCV
  #include "vsiptest_rscv.c"
#endif

#ifdef VSIPTEST_ELWISE_COMPLEXTOREAL
  #include "vsiptest_complextoreal.c"
#endif

#ifdef VSIPTEST_ELWISE_REALTOSCALAR
  #include "vsiptest_realtoscalar.c"
#endif

#ifdef VSIPTEST_ELWISE_REALTOSCALAR2
  #include "vsiptest_realtoscalar2.c"
#endif

#ifdef VSIPTEST_ELWISE_REALBINARY
  #include "vsiptest_realbinary.c"
#endif

#ifdef VSIPTEST_ELWISE_COMPLEXSCALAR
  #include "vsiptest_complexscalar.c"
#endif

#ifdef VSIPTEST_ELWISE_REALUNARY
  #include "vsiptest_realunary.c"
#endif

#ifdef VSIPTEST_ELWISE_COMPLEXVTOS
  #include "vsiptest_complexvectorstoscalar.c"
#endif

#ifdef VSIPTEST_ELWISE_COMPLEXBINARY
  #include "vsiptest_complexbinary.c"
#endif

#ifdef VSIPTEST_ELWISE_COMPLEXUNARY
  #include "vsiptest_complexunary.c"
#endif

#ifdef VSIPTEST_ELWISE_REALSCALAR
  #include "vsiptest_realscalar.c"
#endif
