/* vsiptest_block.h Version 0.001 18 March 1999
//
// This file contains the vsiptest_block.h header information
// for all block related functions.
//
// Copyright May 1997, Georgia Institute of Technology.
// This is an unpublished work. All rights reserved.
//
// Author: Thomas Egolf
//         egolf@ece.gatech.edu
// Adapted by: Randall Janka
//             randall.janka@gtri.gatech.edu
//
// Revision History:
// May 6, 1997	Added copyright notice.	   
// 18 March 1999  Adapted for TSL.     */

/* Include files for testing the block functions */

#include"vsip.h"
#include"vsiptest_util.h"

#define elements(x) sizeof(x)/sizeof(x[0])

const int VSIPTEST_BLOCKADMIT_BLOCK_SIZE = 5000;
const int VSIPTEST_BLOCKBIND_SIZE_ARRAY[] = {2, 100, 500, 5000};
const int VSIPTEST_BLOCKBIND_BLOCK_SIZE = 5000;
const int VSIPTEST_BLOCKCREATE_F_BLOCK_SIZE[] = {2, 102, 500, 5000};
const int VSIPTEST_BLOCKCREATE_I_BLOCK_SIZE[] = {2, 102, 500, 5000}; 
const int VSIPTEST_CBLOCKCREATE_F_BLOCK_SIZE[] = {2, 102, 500, 5000};
const int VSIPTEST_BLOCKDESTROY_F_BLOCK_SIZE[] = {2, 100, 500, 1000, 5002};
const int VSIPTEST_BLOCKDESTROY_I_BLOCK_SIZE[] = {2, 100, 500, 1000, 5002};
const int VSIPTEST_CBLOCKDESTROY_F_BLOCK_SIZE[] = {2, 100, 500, 1000, 5002};
const int VSIPTEST_BLOCKFIND_F_BLOCK_SIZE[] = {2, 100, 500, 1000, 5002};
const int VSIPTEST_BLOCKFIND_I_BLOCK_SIZE[] = {2, 100, 500, 1000, 5002};
const int VSIPTEST_CBLOCKFIND_F_BLOCK_SIZE[] = {2, 100, 500, 1000, 5002};
const int VSIPTEST_BLOCKREBIND_BLOCK_SIZE = 5000;
const int VSIPTEST_BLOCKRELEASE_BLOCK_SIZE = 5000;
const int VSIPTEST_VPUT_F_BLOCK_SIZE = 5000;
const int VSIPTEST_INIT_REPETITIONS = 100;
const int VSIPTEST_INIT_NESTING_LEVELS = 100;

/*
//  Definitions used for testing the functions:
//      1) vsip_blockcreate_f.c
//      2) vsip_cblockcreate_f.c
//      3) vsip_blockbind_f.c
//      4) vsip_blockfind_f.c
//      5) vsip_blockdestroy_f.c   */
#define BLOCK_LENGTH_MAX 5002
#define BLOCK_STRIDE 100

#define BLOCK_SIZE   5000
/*
//  Definitions used for testing the functions:
//      1) vsip_blockdestroy_f.c  */
#define NUMBER_OF_VIEWS 10
#define NUMBER_TO_DESTROY 10
