%File:							vsip_cvconj_gen.m
%	
%Author:							Randy Janka
%Date:							12/5/99
%Reference:			
%
%Purpose:						Generate test data for vsip_cvconj_f
%									Generate x=a+jb and y=conj(x)=a-jb
%										where x is a vector of length N
%	
%Parameters:					N = Length = length(x) = 1403
%									DATAPATH = dir where data file is to go;
%										set in workspace

%x=0
%
x0=0;

%x>0
%
xpos=10.^[-7:0.02:7];

%x<0
%
xneg=-fliplr(xpos);

%Form x
x=[xneg,x0,xpos];
u=shuffle(x);
v=shuffle(u);
x_out=u+j*v;

%Form y
y_out=conj(x_out);

%Write data file
N=length(y_out);
out=[real(x_out); imag(x_out); real(y_out); imag(y_out)];
fid=fopen([DATAPATH,'\cvconj_f'],'w');
fprintf(fid,'%4d\n',N);
fprintf(fid,'%12.7e,%12.7e\t%12.7e,%12.7e\n',out);
status=fclose(fid);

if ~status
   disp('cvconj_f write successful.')
else
   disp('cvconj_f write NOT successful.')
end
