%File:							vsip_cvjmul_gen.m
%	
%Author:							Randy Janka
%Date:							12/5/99
%Reference:			
%
%Purpose:						Generate test data for vsip_cvjmul_f
%									Generate x1=a+jb & x2=c+jd and y=x1.*conj(x2)
%										where x1, x2, & y are vectors of length N
%	
%Parameters:					N = Length = length(x) = 403
%									DATAPATH = dir where data file is to go;
%										set in workspace

%x=0
%
x0=0;

%x>0
%
xpos=10.^[-2:0.02:2];

%x<0
%
xneg=-fliplr(xpos);

%Form x
x=[xneg,x0,xpos];
u=shuffle(x);
v=shuffle(u);
x1_out=u+j*v;
r=shuffle(v);
s=shuffle(r);
x2_out=r+j*s;

%Form y
y_out=x1_out.*conj(x2_out);
%Write data file
N=length(x1_out);
out=[real(x1_out); imag(x1_out); real(x2_out); imag(x2_out); real(y_out); imag(y_out)];
fid=fopen([DATAPATH,'\cvjmul_f'],'w');
fprintf(fid,'%4d\n',N);
fprintf(fid,'%12.7e,%12.7e\t%12.7e,%12.7e\t%12.7e,%12.7e\n',out);
fprintf(fid,'%12.7e\n',y_out);
status=fclose(fid);

if ~status
   disp('cvjmul_f write successful.')
else
   disp('cvjmul_f write NOT successful.')
end
