%File:							vsip_cvmag_gen.m
%	
%Author:							Randy Janka
%Date:							12/6/99
%Reference:			
%
%Purpose:						Generate test data for vsip_cvmag_f
%									Generate x=a+jb and y=mag(x)=|a+jb|
%										where x is a vector of length N
%	
%Parameters:					N = Length = length(x) = 404
%									DATAPATH = dir where data file is to go;
%										set in workspace

%x=0
%
x0=0;

%x>0
%
xpos=10.^[-2:0.02:2];

%x<0
%
xneg=-fliplr(xpos);

%Form x
x=[xneg,x0,xpos];
u=shuffle(x);
v=shuffle(u);
x_out=[0,u+j*v];

%Form y
y_out=abs(x_out);
%Write data file
N=length(y_out);
out=[real(x_out); imag(x_out); y_out];
fid=fopen([DATAPATH,'\cvmag_f'],'w');
fprintf(fid,'%4d\n',N);
fprintf(fid,'%12.7e,%12.7e\t%12.7e\n',out);
status=fclose(fid);

if ~status
   disp('cvmag_f write successful.')
else
   disp('cvmag_f write NOT successful.')
end
