%File:						vsip_svmul_gen.m
%
%Author:						Randy Janka
%Date:						12/5/99
%Reference:					
%
%Purpose:					Generate test data for vsip_svmul_f
%								Generate x & s and y=s*x
%									where x is a vector of length N
%									  and s is a scalar
%
%Parameters:				N = Length = length(x) = 403
%								DATAPATH = dir where data file is to go;
%									set in workspace

%x=0
%
x0=0;

%x>0
%
xpos=10.^[-2:0.02:2];

%x<0
%
xneg=-fliplr(xpos);

%Form x
x=[xneg,x0,xpos];
x_out=shuffle(x);
s=12.34;

%Form y
y_out=s*x_out;

%Write data file
N=length(x_out);
out=[x_out; y_out];
fid=fopen([DATAPATH,'\svmul_f'],'w');
fprintf(fid,'%4d\n',N);
fprintf(fid,'%12.7e\n',s);
fprintf(fid,'%12.7e\t%12.7e\n',out);
status=fclose(fid);

if ~status
   disp('svmul_f write successful.')
else
   disp('svmul_f write NOT successful.')
end
