%File:							vsip_vcmplx_gen.m
%	
%Author:							Randy Janka
%Date:							11/30/99
%Reference:			
%
%Purpose:						Generate test data for vsip_vcmplx_f
%									Generate x_re & x_im and y=x_re+j*x_im
%										where x_* & y are vectors of length N
%	
%Parameters:					N = Length = length(x) = 2000
%									DATAPATH = dir where data file is to go;
%										set in workspace

%Form x
%
N=2000;
x_re=[-N/2:(N/1)-1];
x_im=fliplr(x_re);

%Form y
y=x_re+j*x_im;

%Write data file
out=[real(y); imag(y)];
fid=fopen([DATAPATH,'\vcmplx_f'],'w');
fprintf(fid,'%4d\n',N);
fprintf(fid,'%12.7e\t%12.7e\n',out);
status=fclose(fid);

if ~status
   disp('vcmplx_f write successful.')
else
   disp('vcmplx_f write NOT successful.')
end
