%File:						vsip_vcos_gen.m
%
%Author:						Randy Janka
%Date:						12/5/99
%Reference:					Chapter 8 of Cody/Waite
%
%Purpose:					Generate test data for vsip_vcos_f
%								Generate x=[0:2*pi_sp], y=cos(x)
%
%Parameters:				N = Length = length(x) = 1024
%								DATAPATH = dir where data file is to go;
%									set in workspace

%Constants
pi_sp=3.141593; % Single precision approximation of PI
pi_sp2=2*pi_sp;
N=1024;
Ndiv4=N/4;
delta_arg=2*pi_sp/N;

%Unit circle axis values
%
arg0=[0,pi_sp/2,pi_sp,3*pi_sp/2];

%Form x
x_out=zeros(1,N);
for quadrant=1:4,
   n=quadrant-1;
   n1=n*(N/4)+1;
   nN=n1+N/4-1;
   arg(n1)=arg0(quadrant);
   argQ=n*(pi_sp/2)+[1:(Ndiv4-1)]*delta_arg;
   x=[arg0(quadrant),shuffle(argQ)];
   %x=[arg0(quadrant),argQ];
   x_out(n1:nN)=x;
end

%Form y
y_out=cos(x_out);

%Write data file
out=[x_out; y_out];
fid=fopen([DATAPATH,'\vcos_f'],'w');
fprintf(fid,'%4d\n',N);
fprintf(fid,'%12.7e\t%12.7e\n',out);
status=fclose(fid);

if ~status
   disp('vcos_f write successful.')
else
   disp('vatan2_f write NOT successful.')
end
