%File:							vsip_vdot_gen.m
%	
%Author:							Randy Janka
%Date:							11/27/99
%Reference:			
%
%Purpose:						Generate test data for vsip_vdot_f
%									Generate x1 & x2 and y=x1*x2
%										where x1 & x2 are vectors of length N
%	
%Parameters:					N = Length = length(x) = 1403
%									DATAPATH = dir where data file is to go;
%										set in workspace

%x=0
%
x0=0;

%x>0
%
xpos=10.^[-7:0.02:7];

%x<0
%
xneg=-fliplr(xpos);

%Form x
x1=[xneg,x0,xpos];
x1_out=shuffle(x1);
x2_out=shuffle(x1_out);

%Form y
y_out=x1_out*x2_out.';

%Write data file
N=length(x1_out);
out=[real(x1_out); imag(x1_out); real(x2_out); imag(x2_out)];
fid=fopen([DATAPATH,'\vdot_f'],'w');
fprintf(fid,'%4d\n',N);
fprintf(fid,'%12.7e\t%12.7e\t%12.7e\t%12.7e\n',out);
fprintf(fid,'%12.7e\n',y_out);
status=fclose(fid);

if ~status
   disp('vdot_f write successful.')
else
   disp('vdot_f write NOT successful.')
end
