%File:						vsip_vexp_gen.m
%
%Author:						Randy Janka
%Date:						11/26/99
%Reference:					Chapter 6 of Cody/Waite
%
%Purpose:					Generate test data for vsip_vexp_f
%								Generate x and y=exp(x)
%									where x is a vector of length N
%
%Parameters:				N = Length = length(x) = 1140
%								DATAPATH = dir where data file is to go;
%									set in workspace

%Primary range:			|x|<xmax; xmax=45/16
xmax=45/16;
x0=[-xmax:0.005:xmax];
%Large values of |x|:	xmax<|x|<10 for single precision
xpos=[3:9];
xneg=-fliplr(xpos);

%Form x
x=[xneg,x0,xpos];
x_out=shuffle(x);

%Form y
y_out=exp(x_out);

%Write data file
N=length(x);
out=[x_out; y_out];
fid=fopen([DATAPATH,'\vexp_f'],'w');
fprintf(fid,'%4d\n',N);
fprintf(fid,'%12.7e\t%12.7e\n',out);
status=fclose(fid);

if ~status
   disp('vexp_f write successful.')
else
   disp('vexp_f write NOT successful.')
end
