%File:							vsip_vmax_gen.m
%	
%Author:							Randy Janka
%Date:							12/5/99
%Reference:			
%
%Purpose:						Generate test data for vsip_vmax_f
%									Generate x1 & x2 and y=max(x1,x2)
%										where x1 & x2 & y are vectors of length N
%	
%Parameters:					N = Length = length(x) = 2*xmax = 508
%									DATAPATH = dir where data file is to go;
%										set in workspace

%Form x
%
xmax=254;
x1=[(-[xmax:-1:1]),0,(-[1:xmax-1])]/100.;
x2=sort([[-xmax:2:xmax-1],[-xmax:2:xmax-1]]);
x2(xmax+2:2*xmax)=x2(xmax+2:2*xmax)+1;
x2([1:2:(2*xmax-1)])=-x2([1:2:(2*xmax-1)]);
x2=x2/100.;

%Form y
y=max([x1;x2]);

%Write data file
N=length(y);
out=[x1; x2; y];
fid=fopen([DATAPATH,'\vmax_f'],'w');
fprintf(fid,'%4d\n',N);
fprintf(fid,'%12.7e\t%12.7e\t%12.7e\n',out);
status=fclose(fid);

if ~status
   disp('vmax_f write successful.')
else
   disp('vmax_f write NOT successful.')
end
