%File:							vsip_vminval_gen.m
%	
%Author:							Randy Janka
%Date:							12/5/99
%Reference:			
%
%Purpose:						Generate test data for vsip_vminval_f
%									Generate x and [val,index]=min(x)
%										where x is a vector of length N
%										with 2 min vals
%	
%Parameters:					N = Length = length(x) = 2000
%									DATAPATH = dir where data file is to go;
%										set in workspace

%Form x
%
x=rand(1,2000);
x([1000:1010])=-10.;
x([1999:2000])=-42.;
x_out=x;

%Form y
[val,index]=min(x_out);
%Write data file
N=length(x_out);
fid=fopen([DATAPATH,'\vminval_f'],'w');
fprintf(fid,'%4d\n',N);
fprintf(fid,'%12.7e\n',val);
fprintf(fid,'%4d\n',index-1); 
% Matlab starts index on 1; VSIPL starts index on 0.
fprintf(fid,'%12.7e\n',x_out);
status=fclose(fid);

if ~status
   disp('vminval_f write successful.')
else
   disp('vminval_f write NOT successful.')
end
