%File:						vsip_vneg_gen.m
%
%Author:						Randy Janka
%Date:						11/26/99
%Reference:					
%
%Purpose:					Generate test data for vsip_vneg_f
%								Generate x and y=neg(x)
%									where x is a vector of length N
%
%Parameters:				N = Length = length(x) = 1403
%								DATAPATH = dir where data file is to go;
%									set in workspace

%x=0
%
x0=0;

%x>0
%
xpos=10.^[-7:0.02:7];

%x<0
%
xneg=-fliplr(xpos);

%Form x
x=[xneg,x0,xpos];
x_out=shuffle(x);

%Form y
y_out=-x_out;

%Write data file
N=length(y_out);
out=[x_out; y_out];
fid=fopen([DATAPATH,'\vneg_f'],'w');
fprintf(fid,'%4d\n',N);
fprintf(fid,'%12.7e\t%12.7e\n',out);
status=fclose(fid);

if ~status
   disp('vneg_f write successful.')
else
   disp('vneg_f write NOT successful.')
end
