%File:					vsip_vsq_gen.m
%
%Author:					Randy Janka
%Date:					11/26/99
%Reference:				Chapter 6 of Cody/Waite
%							Adapted from exp
%
%Purpose:				Generate test data for vsip_vsq_f
%							Generate x and y=sq(x)
%								where x is a vector of length N
%
%Parameters:			N = Length = length(x) = 1023
%							DATAPATH = dir where data file is to go;
%									set in workspace

%Primary range:				|x|<xmax; xmax=5
xmax=5;
x0=[-xmax:0.01:xmax];

%Large values of |x|:		xmax<|x|<10^7 for single precision
xpos=[[6:9],10.^[1:7]];
xneg=-fliplr(xpos);

%Form x
x=[xneg,x0,xpos];
x_out=shuffle(x);

%Form y
y_out=x_out.*x_out;

%Write data file
N=length(x);
out=[x_out; y_out];
fid=fopen([DATAPATH,'\vsq_f'],'w');
fprintf(fid,'%4d\n',N);
fprintf(fid,'%12.7e\t%12.7e\n',out);
status=fclose(fid);

if ~status
   disp('vsq_f write successful.')
else
   disp('vsq_f write NOT successful.')
end
