%File:						vsip_vsub_gen.m
%
%Author:						Randy Janka
%Date:						12/1/99
%Reference:					
%
%Purpose:					Generate test data for vsip_vsub_f
%								Generate x1 & x2 and y=x1-x2
%									where x1 & x2 are vectors of length N
%
%Parameters:				N = Length = length(x) = 410
%								DATAPATH = dir where data file is to go;
%									set in workspace

%x=0
%
x0=0;

%x>0
%
xpos=10.^[-1:0.7:4];

%x<0
%
xneg=-(10.^[-2:0.01:2]);

%Form x
x=[xneg,x0,xpos];
x1_out=shuffle(x);
x2_out=shuffle(x1_out);

%Form y
y_out=x1_out-x2_out;

%Write data file
N=length(x1_out);
out=[x1_out; x2_out; y_out];
fid=fopen([DATAPATH,'\vsub_f'],'w');
fprintf(fid,'%4d\n',N);
fprintf(fid,'%12.7e\t%12.7e\t%12.7e\n',out);
status=fclose(fid);

if ~status
   disp('vsub_f write successful.')
else
   disp('vsub_f write NOT successful.')
end
