/* vsiptest_tolerances.c Version 0.001 12 June 2000
//
// This file contains the vsiptest_block.h header information
// for all block related functions.
//
// Copyright May 2000, Georgia Institute of Technology.
// This is an unpublished work. All rights reserved.
//
// Author: Dan Campbell 
//				 dan.campbell@gtri.gatech.edu
//
// Revision History:
// 12 June 2000   Created
*/

#include "vsiptest_elwise_test_defs.h"
#include "vsiptest_sigproc.h"

int main (void)
{
  printf ("Tolerances used for numerical testing of vsip functions:\n");
	printf ("vsiptest_rscvmul_f   : %f\n", VSIPTEST_RSCVMUL_F_EPSILON_MAX);
	printf ("vsiptest_vdot_f      : %f\n", VSIPTEST_VDOT_F_EPSILON_MAX);
	printf ("vsiptest_vfill_f     : %f\n", VSIPTEST_VFILL_F_EPSILON_MAX);
	printf ("vsiptest_rcvmul_f    : %f\n", VSIPTEST_RCVMUL_F_EPSILON_MAX);
	printf ("vsiptest_csvmul_f    : %f\n", VSIPTEST_CSVMUL_F_EPSILON_MAX);
	printf ("vsiptest_cvjdot_f    : %f\n", VSIPTEST_CVJDOT_F_EPSILON_MAX);
	printf ("vsiptest_cvdot_f     : %f\n", VSIPTEST_CVDOT_F_EPSILON_MAX);
	printf ("vsiptest_vminval_f   : %f\n", VSIPTEST_VMINVAL_F_EPSILON_MAX);
	printf ("vsiptest_vmaxval_f   : %f\n", VSIPTEST_VMAXVAL_F_EPSILON_MAX);
	printf ("vsiptest_vcmagsq_f   : %f\n", VSIPTEST_VCMAGSQ_F_EPSILON_MAX);
	printf ("vsiptest_vimag_f     : %f\n", VSIPTEST_VIMAG_F_EPSILON_MAX);
	printf ("vsiptest_vreal_f     : %f\n", VSIPTEST_VREAL_F_EPSILON_MAX);
	printf ("vsiptest_cvmag_f     : %f\n", VSIPTEST_CVMAG_F_EPSILON_MAX);
	printf ("vsiptest_svsub_f     : %f\n", VSIPTEST_SVSUB_F_EPSILON_MAX);
	printf ("vsiptest_svmul_f     : %f\n", VSIPTEST_SVMUL_F_EPSILON_MAX);
	printf ("vsiptest_svdiv_f     : %f\n", VSIPTEST_SVDIV_F_EPSILON_MAX);
	printf ("vsiptest_vmin_f      : %f\n", VSIPTEST_VMIN_F_EPSILON_MAX);
	printf ("vsiptest_vmax_f      : %f\n", VSIPTEST_VMAX_F_EPSILON_MAX);
	printf ("vsiptest_vsub_f      : %f\n", VSIPTEST_VSUB_F_EPSILON_MAX);
	printf ("vsiptest_vmul_f      : %f\n", VSIPTEST_VMUL_F_EPSILON_MAX);
	printf ("vsiptest_vdiv_f      : %f\n", VSIPTEST_VDIV_F_EPSILON_MAX);
	printf ("vsiptest_vatan2_f    : %f\n", VSIPTEST_VATAN2_F_EPSILON_MAX);
	printf ("vsiptest_vadd_f      : %f\n", VSIPTEST_VADD_F_EPSILON_MAX);
	printf ("vsiptest_vsq_f       : %f\n", VSIPTEST_VSQ_F_EPSILON_MAX);
	printf ("vsiptest_vrecip_f    : %f\n", VSIPTEST_VRECIP_F_EPSILON_MAX);
	printf ("vsiptest_vneg_f      : %f\n", VSIPTEST_VNEG_F_EPSILON_MAX);
	printf ("vsiptest_vmag_f      : %f\n", VSIPTEST_VMAG_F_EPSILON_MAX);
	printf ("vsiptest_vsqrt_f     : %f\n", VSIPTEST_VSQRT_F_EPSILON_MAX);
	printf ("vsiptest_vsin_f      : %f\n", VSIPTEST_VSIN_F_EPSILON_MAX);
	printf ("vsiptest_vlog10_f    : %f\n", VSIPTEST_VLOG10_F_EPSILON_MAX);
	printf ("vsiptest_vlog_f      : %f\n", VSIPTEST_VLOG_F_EPSILON_MAX);
	printf ("vsiptest_vexp_f      : %f\n", VSIPTEST_VEXP_F_EPSILON_MAX);
	printf ("vsiptest_vcos_f      : %f\n", VSIPTEST_VCOS_F_EPSILON_MAX);
	printf ("vsiptest_vatan_f     : %f\n", VSIPTEST_VATAN_F_EPSILON_MAX);
	printf ("vsiptest_vsumsqval_f : %f\n", VSIPTEST_VSUMSQVAL_F_EPSILON_MAX);
	printf ("vsiptest_vsumval_f   : %f\n", VSIPTEST_VSUMVAL_F_EPSILON_MAX);
	printf ("vsiptest_cvmul_f     : %f\n", VSIPTEST_CVMUL_F_EPSILON_MAX);
	printf ("vsiptest_cvjmul_f    : %f\n", VSIPTEST_CVJMUL_F_EPSILON_MAX);
	printf ("vsiptest_cvsub_f     : %f\n", VSIPTEST_CVSUB_F_EPSILON_MAX);
	printf ("vsiptest_cvadd_f     : %f\n", VSIPTEST_CVADD_F_EPSILON_MAX);
	printf ("vsiptest_cvneg_f     : %f\n", VSIPTEST_CVNEG_F_EPSILON_MAX);
	printf ("vsiptest_cvconj_f    : %f\n", VSIPTEST_CVCONJ_F_EPSILON_MAX);
	printf ("vsiptest_ccfftop_f   : %f\n", VSIPTEST_CCFFTOP_F_MAX_EPSILON);
	printf ("vsiptest_rcfftop_f   : %f\n", VSIPTEST_RCFFTOP_F_MAX_EPSILON);
	printf ("vsiptest_crfftop_f   : %f\n", VSIPTEST_CRFFTOP_F_MAX_EPSILON);
	printf ("vsiptest_firflt_f    : %f\n", VSIPTEST_FIRFLT_F_MAX_EPSILON);
	printf ("vsiptest_cfirflt_f   : %f\n", VSIPTEST_CFIRFLT_F_MAX_EPSILON);
	printf ("vsiptest_vhisto_f    : %f\n", VSIPTEST_VHISTO_F_MAX_EPSILON);
	printf ("vsiptest_vrandu_f    : %f\n", VSIPTEST_VRANDU_F_MAX_EPSILON);

	return 0;
}

