#include "vsiptest_util.h"
#include <stdarg.h>
#include <stdio.h>
#include <math.h>

double max_error;
double macro_max_error;
double total_error_sq;
int count;
int error_level;
char biggest_buff[2048];
char buffer[1024];
char buffer2[1024];
int init = -1;

void reset_counts(void)
{
  total_error_sq = 0;
  max_error = -1;
}

void error_init (char *arg)
{
  if (arg)
  {
    error_level = atoi (arg);
  }
  else
  {
    error_level = 0;
  }
  reset_counts();
  macro_max_error = -1;
}

void update_error_element (double error)
{
  if (error > max_error)
  {
    max_error = error;
  }
  total_error_sq += error*error;
  count++;
}

void update_error_total (void)
{
}

void error_report_test (char *fmt, ...)
{
  va_list argp;
  double RMS;

  va_start(argp, fmt);
  vsprintf (buffer, fmt, argp);
  va_end(argp);

  RMS = sqrt (total_error_sq/(double)count);

  sprintf (buffer2, "%s\n\tmax error: %f\n\tRMS error=%f\n", buffer, max_error, RMS);
  
  if (max_error > macro_max_error)
  {
    macro_max_error = max_error;
    sprintf (biggest_buff, buffer2);
  }
  if (error_level > 1)
  {
    vtprintf (buffer2);
  }
  reset_counts();
}

void error_finish (void)
{
  if (error_level)
  {
    vtprintf ("Largest error:\n%s", biggest_buff);
  }
}

