/* vsiptest_viewutil.c Version 0.000 August 2, 1999
// 
// This file contains user utility functions for view tests
// 
// Copyright August 1999, Georgia Institute of Technology.
// This is an unpublished work. All rights reserved.
//
// Author: Dan Campbell 
//         dan.campbell@gtri.gatech.edu
//
//
// Revision History:
// August 2, 1999   Created
*/

#include "vsip.h"

void vsip_vcopy_f_i (const vsip_vview_f *tview, const vsip_vview_i *view);
void vput_i (vsip_vview_i *view, int pos, vsip_scalar_i val);
vsip_scalar_i vget_i (vsip_vview_i *view, int pos);

vsip_scalar_i vget_i (vsip_vview_i *view, int pos)
{
  vsip_vview_f *tview;
  vsip_vattr_i attrib;
  vsip_scalar_f val;

  vsip_vgetattrib_i (view, &attrib);

  tview = vsip_vcreate_f (attrib.length, 0);
  vsip_vcopy_i_f (view, tview);

  val = vsip_vget_f(tview, pos);
  vsip_vdestroy_f (tview);
  return ((vsip_scalar_i)val);
}


void vput_i (vsip_vview_i *view, int pos, vsip_scalar_i val)
{
  vsip_vview_f *tview;
  vsip_vattr_i attrib;

  vsip_vgetattrib_i (view, &attrib);

  tview = vsip_vcreate_f (attrib.length, 0);

  vsip_vcopy_i_f (view, tview);
  vsip_vput_f(tview, pos, (vsip_scalar_f)val);
  vsip_vcopy_f_i (tview, view);
  vsip_vdestroy_f (tview);
}


